#pragma once
#include <Engine/Ska/Render.h>
#include <Engine/Templates/StaticArray.h>
#include <Engine/Base/Serial.h>

typedef FLOAT Matrix3x4[12];

class ENGINE_API CAnimSet : public CSerial
{
public:
  CAnimSet();
  ~CAnimSet();
  void Read_t( CTStream *istrFile); // throw char *
  void Write_t( CTStream *ostrFile); // throw char *
  void Clear(void);

  CStaticArray<struct Animation> as_Anims;
};

struct Animation
{
  int an_iID;
  FLOAT an_fSecPerFrame;
  INDEX an_iFrames;
  CStaticArray<struct MorphEnvelope> an_ameMorphs;
  CStaticArray<struct BoneEnvelope> an_abeBones;
};

struct MorphEnvelope
{
  int me_iMorphMapID;
  CStaticArray<FLOAT> me_aFactors;
};

struct BoneEnvelope
{
  int be_iBoneID;
  Matrix3x4 be_mDefaultPos;
  CStaticArray<struct QVect> be_aqvPlacement;
  FLOAT be_OffSetLen;
};

